program number;

uses Objects,Hex,ffurie;

const
  FR = 9000;
  SZ = 8600;
  fF0 = 700;
  dF = 200;
  F0 = 2;
  F1 = 4;
  F2 = 8;
  F4 = 16;
  F7 = 32;
  F11 = 64;
  chars : Array [1..14] of byte = (
           F4 + F7,  { 0 }
           F0 + F1,  { 1 }
           F0 + F2,  { 2 }
           F1 + F2,  { 3 }
           F0 + F4,  { 4 }
           F1 + F4,  { 5 }
           F2 + F4,  { 6 }
           F0 + F7,  { 7 }
           F1 + F7,  { 8 }
           F2 + F7,  { 9 }
           F0 + F11, { ':' H}
           F1 + F11, { ';' }
           F4 + F11, { '<' }
           F2 + F11);{ '='   }

procedure GetBuffer(var Buff : Pointer);
var
  S : pDosStream;
  Size : LongInt;
begin
  New(S,Init(ParamStr(1),stOpenRead));
  S^.Seek(2);
  Size := S^.GetSize - 2;
  if Size > SZ then Size := SZ;
  GetMem(Buff, Size);
  S^.Read(Buff^, Size);
  Dispose(S,Done);
end;

function GetCode(var S : Spectr) : Byte;
var
  Freq : Array [0..6] of Word;
  M1,M2,M3 : Word;

procedure Get3Max;
var
  rn : Word;
begin
  M1 := 0;
  M2 := 0;
  M3 := 0;
  Freq[0] := 0;
  for rn := 1 to 6 do
  begin
    if Freq[rn] > Freq[M1] then
    begin
      M3 := M2;
      M2 := M1;
      M1 := rn;
    end else
    if Freq[rn] > Freq[M2] then
    begin
      M3 := M2;
      M2 := rn;
    end else
    if Freq[rn] > Freq[M3] then
    M3 := rn;
  end;
end;

var
  F : Word;
  rn : Word;
begin
  F := fF0;
  for rn := 1 to 6 do
    asm
      xor dh,dh
      mov dl,byte ptr F+1
      xor al,al
      mov ah,byte ptr F
      mov bx,FR
      div bx
      dec ax

      shl ax,1
      shl ax,1
      les di,S
      add di,ax
      mov cx,8
      mov bx,0
@1:   mov ax,Word ptr es:[di]
      imul ax
      add bx,dx
      add di,Type Complex / 2;
      loop @1

      mov si,rn
      shl si,1
      mov Word Ptr [freq + si],bx
      add F,dF
    end;
  Get3Max;
  GetCode := 0;
  if Freq[M3] > (Freq[M2] div 3) shl 1 then Exit;
  GetCode := (1 shl M2) or (1 shl M1);
end;

const
  Nm = 16;
type
  tNumbArray = array [0..Nm -1] of char;

procedure MakeNumber(var Buff : tByteArray; var C : tNumbArray);
var
  rn,rs : Integer;
  Code,Prev,control,count : Byte;
  Spc : Spectr;
label Break;
begin
  rn := Nm;
  rs := 0;
  Prev := 0;
  Count := 0; {稪  ᨬ}
  while (rn >= 0)
  and (rs < SZ-N) do
  begin
    ToSpectr(Buff[rs],Spc);
    Code := GetCode(Spc);
    Inc(rs,150);
    if (Code <> prev)
    and (Code <> 0) then
    begin
      Control := Posit(Chars,Code,SizeOf(Chars));
      if Control <> 0 then
      begin
        Dec(rn);
        C[rn] := Char(Control + Byte('0')-1);
        Prev := Code;
        Count := 0;
      end else
      begin
        Inc(Count);
{        if Count > 2 then goto Break;}
      end;
    end;
  end;
Break :
  Move(C[rn],C[0],Nm-rn);
  FillChar(C[Nm-rn],rn,' ');
end;

var
  Buff : ^tByteArray;
  Numb : tNumbArray;
  Time : LongInt Absolute $40:$6C;
  OldT : LongInt;
begin
  FillChar(Numb,Nm,'_');
  GetBuffer(Pointer(Buff));
  OldT := Time;
  MakeNumber(Buff^,Numb);
  Writeln(StringTime(Time-OldT));
  writeln(Numb);
{  Read(numb[0]);}
end.